$COM 0 'kein serieller Puffer
$CPU 80386 'CPU >=80386
$DEBUG MAP OFF 'Keine Mapdateien
$DEBUG PBDEBUG OFF 'Keine Debuginformationen
$DEBUG PATH OFF 'Kein Debugpfad
$DEBUG UNIT OFF 'Keine Debuginformationen fr Units
$DIM ARRAY 'Nur Felder dimensionieren
$ERROR ALL OFF 'Fehlerberwachung aus
$FLOAT NPX 'Koprozessoremulator nicht einbinden
$LIB COM -, LPT -, Graph -, FULLFLOAT -, IPRINT - 'Keine Bibliotheken
$OPTIMIZE Size 'schnellen Code erzeugen
$OPTION CNTLBREAK - 'Control Break nicht zulassen
$OPTION GOSUB - 'Pfade bei Fehlern nicht beibehalten
$OPTION SIGNED - 'IEEE-Format bei Fehlern
$SOUND 1 'minimaler Musikpuffer
$STACK 2048 'kleinstmglicher Stack
$STATIC 'statische Felder erzeugen
$STRING 32 'Stringsegmentgre=1kB
$EVENT OFF 'keine Ablaufverfolgung
OPTION BINARY BASE 0 'erstes Dateielement=Nr. 0
OPTION ARRAY BASE 0 'erstes Feldelement=Nr. 0
DEFINT a - z 'Standardvariablen=integer

'Hinweis: dies ist ein Quelltext in der Programmiersprache PowerBasic for
'DOS Version 3.50

ON ERROR GOTO ubk

CLS

IF LCASE$( COMMAND$ ) < > "xyz" THEN _
? "Bitte die GKP007.BAT starten, nicht die .EXE": SLEEP 5: END 255

eco = 1: CALL dateifrei( "gordia~?.exe", "gordiank.exe", gknotname$ )
CHDIR "language"
eco = 2: CALL dateifrei( "GK_eng~?.ini", "GK_engli.ini", engname$ )
eco = 3: CALL dateifrei( "GK_ger~?.ini", "GK_germa.ini", gername$ )
CHDIR ".."

eco = 4: OPEN gknotname$ FOR INPUT AS #1
IF LOF( 1 ) < 940000 THEN _
? "Die Gordianknot.exe ist gepackt. Bitte vorher mit UPX lt. Anleitung entpacken!": _
SLEEP 60: END 255
CLOSE

eco = 5: CALL patchfile( gknotname$, "gordiank.exe" )
CHDIR "language"
eco = 6: CALL patchfile( engname$, "GK_englis.ini" )
eco = 7: CALL patchfile( gername$, "GK_germa.ini" )
CHDIR ".."

CLS: BEEP 1: ? "fertig": END 0

SUB patchfile( namekz$, tempname$ )
  OPEN namekz$ FOR BINARY AS #1
  OPEN tempname$ FOR output AS #2
  GET$ #1, 2050, temp$
  DO
    puffer$ = RIGHT$( puffer$, MAX( LEN( puffer$ ) - 2000, 0 )) + temp$

'2 Hinweise fr Bastler:
'  1: Der Text vor dem "WITH" und der Text nach dem "WITH" MUSS! exakt gleich
'     lang sein
'  2: Maximale Ersetzlnge=50 Zeichen! Sonst die Zahl 2050 hier drber ent-
'     sprechend erhhen

    REPLACE "decomb.dll" WITH "Tdeint.dll" IN puffer$
    REPLACE "Field Deinterlace" WITH "ohne Funktion    " IN puffer$
    REPLACE "ohne Funktion     (no blend)" WITH "TDeint                      " IN puffer$
    REPLACE "ohne Funktion     (kein blending)" WITH "TDeint                           " IN puffer$
    REPLACE "FieldDeinterlace()" WITH "                  " IN Puffer$
    REPLACE "FieldDeinterlace(blend=false)" WITH "TDeint(full=false)           " IN puffer$

    ? #2, LEFT$( puffer$, 2000 );

    GET$ #1, 2000, temp$

  LOOP UNTIL puffer$ = ""
  CLOSE

END SUB

dng:
? "Problem mit Dateizugriffen 007 /"; ERR; "/"; ERADR; "/"; eco: SLEEP 5: END 255

ubk:
? "unbekannter Fehler 007 /"; ERR; "/"; ERADR; "/"; eco: SLEEP 5: END 255
RESUME ubk2
ubk2:
END 255

SUB dateifrei( originalname$, tempname$, istname$ )
  IF DIR$( xname$( originalname$ )) < > "" THEN dng
  IF DIR$( tempname$ ) < > "" THEN dng
  istname$ = DIR$( originalname$ )
  IF DIR$ < > "" THEN dng
  ON ERROR GOTO dng
  OPEN istname$ FOR INPUT LOCK READ WRITE AS #1: CLOSE
  ON ERROR GOTO ubk
END SUB

FUNCTION xname$( ohnexxx$ )
  FUNCTION = extract$( ohnexxx$, "." ) + ".xxx"
END FUNCTION
